module IIC_IP_tb();

	reg clk;
	reg rst_n;
	reg iic_en;
	reg write_to_read_en;
	reg [6:0] w_slave_addr;
	reg w_r_cmd;
	reg [7:0] w_reg_addr;
	reg [7:0] w_data_byte;
	reg [7:0] w_data_one;
	reg [7:0] w_data_two;
	reg [7:0] w_data_three;
	reg [7:0] w_data_four;
	wire [7:0] R_DATA_MSB;
	wire [7:0] R_DATA_LSB;
	wire IIC_FINISH;
	wire SCL;
	wire SDA;

	//----Code starts here: integrated by Robei-----
	//---------------------write test------------------------
	initial begin
					clk<=1'b0; rst_n<=1'b0;
	#200		rst_n<=1'b1;
	
	#200		iic_en<=1'b1; w_r_cmd<=1'b0; 
					w_slave_addr=7'b010_0001; w_data_byte=8'd4; 
					w_data_one=8'b0011_0101; w_data_two=8'b1011_0010; 
					w_data_three=8'b1101_0111; w_data_four=8'b0001_0101;
					
	#40000 $finish;
	
	end
	
	always #1 clk<=~clk;
	
	
	//-------------------read test----------------------
	/*initial begin
					clk<=1'b0; rst_n<=1'b0;
	#200		rst_n<=1'b1;
	
	#200		iic_en<=1'b1; w_r_cmd<=1'b1; 
					w_slave_addr=7'b010_0001;
					
	#40000 $finish;
	
	end
	
	always #1 clk<=~clk;
	*/
	initial begin
		$dumpfile ("F:/Robei_competition_common_ip/communication_protocol_type/IIC_drive/IIC_IP_tb.vcd");
		$dumpvars;
	end
	//---Module instantiation---
	i2c_ip i2c_ip1(
		.clk(clk),
		.rst_n(rst_n),
		.iic_en(iic_en),
		.write_to_read_en(write_to_read_en),
		.w_slave_addr(w_slave_addr),
		.w_r_cmd(w_r_cmd),
		.w_reg_addr(w_reg_addr),
		.w_data_byte(w_data_byte),
		.w_data_one(w_data_one),
		.w_data_two(w_data_two),
		.w_data_three(w_data_three),
		.w_data_four(w_data_four),
		.R_DATA_MSB(R_DATA_MSB),
		.R_DATA_LSB(R_DATA_LSB),
		.IIC_FINISH(IIC_FINISH),
		.SCL(SCL),
		.SDA(SDA));

endmodule    //IIC_IP_tb

