module i2c_ip(
	clk,
	rst_n,
	iic_en,
	write_to_read_en,
	w_slave_addr,
	w_r_cmd,
	w_reg_addr,
	w_data_byte,
	w_data_one,
	w_data_two,
	w_data_three,
	w_data_four,
	R_DATA_MSB,
	R_DATA_LSB,
	IIC_FINISH,
	SCL,
	SDA);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input iic_en;
	input write_to_read_en;
	input [6:0] w_slave_addr;
	input w_r_cmd;
	input [7:0] w_reg_addr;
	input [7:0] w_data_byte;
	input [7:0] w_data_one;
	input [7:0] w_data_two;
	input [7:0] w_data_three;
	input [7:0] w_data_four;
	output [7:0] R_DATA_MSB;
	output [7:0] R_DATA_LSB;
	output IIC_FINISH;
	output SCL;
	inout SDA;

	wire clk;
	wire rst_n;
	wire iic_en;
	wire write_to_read_en;
	wire [6:0] w_slave_addr;
	wire w_r_cmd;
	wire [7:0] w_reg_addr;
	wire [7:0] w_data_byte;
	wire [7:0] w_data_one;
	wire [7:0] w_data_two;
	wire [7:0] w_data_three;
	wire [7:0] w_data_four;
	wire [7:0] R_DATA_MSB;
	wire [7:0] R_DATA_LSB;
	wire IIC_FINISH;
	wire SCL;
	wire SDA;

	//----Code starts here: integrated by Robei-----
	reg                    [   7:0]         r_data_msb,r_data_lsb      ;
	assign R_DATA_MSB = r_data_msb;
	assign R_DATA_LSB = r_data_lsb;
	
	reg                                     iic_finish                 ;
	assign IIC_FINISH = iic_finish;
	
	reg                                     scl,sda_out,sda_en         ;
	wire                                    sda_in                     ;
	assign SCL = scl;
	assign SDA = sda_en ? sda_out : 1'bz;
	assign sda_in = SDA;
	//ʽ״̬
	    parameter                           IDLE         = 4'd0        ,
	                                        START        = 4'b1                ,
	                                        W_SLAVE_ADDR = 4'd2                ,
	                                        W_REG_ADDR   = 4'd3                ,
	                                        W_DATA_ONE   = 4'd4                ,
	                                        W_DATA_TWO   = 4'd5                ,
	                                        W_DATA_THREE = 4'd6                ,
	                                        W_DATA_FOUR  = 4'd7                ,
	                                        R_DATA_M     = 4'd8                ,
	                                        R_DATA_L     = 4'd9                ,
	                                        STOP         = 4'd10               ,
	                                        FINISH       = 4'd11               ;
	reg                    [   3:0]         cur_state,next_state       ;
	reg                                     state_transition           ;
	reg                    [   5:0]         cnt_step                   ;
	always @(posedge clk or negedge rst_n) begin
	    if(!rst_n) begin
	        cur_state <= IDLE;
	    end
	    else begin
	        cur_state <= next_state;
	    end
	end
	always @(*) begin
	    case(cur_state)
	        IDLE:begin
	            if(iic_en)begin
	                next_state <= START;
	            end
	            else begin
	                next_state <= IDLE;
	            end
	        end
	        START:begin
	            if (state_transition) begin
	                next_state <= W_SLAVE_ADDR;
	            end
	            else begin
	                next_state <= START;
	            end
	        end
	        W_SLAVE_ADDR:begin
	            if (state_transition) begin
	                if(w_r_cmd)begin
	                    next_state <= R_DATA_M;
	                end
	                else begin
	                    next_state <= W_REG_ADDR;
	                end
	            end
	            else begin
	                next_state <= W_SLAVE_ADDR;
	            end
	        end
	        W_REG_ADDR:begin
	            if (state_transition) begin
	                if(write_to_read_en)begin
	                    next_state <= START;
	                end
	                else begin
	                    next_state <= W_DATA_ONE;
	                end
	            end
	            else begin
	                next_state <= W_REG_ADDR;
	            end
	        end
	        W_DATA_ONE:begin
	            if (state_transition) begin
	                if(w_data_byte == 3'd1)begin
	                    next_state <= STOP;
	                end
	                else if(w_data_byte == 3'd4)begin
	                    next_state <= W_DATA_TWO;
	                end
	            end
	            else begin
	                next_state <= W_DATA_ONE;
	            end
	        end
	        W_DATA_TWO:begin
	            if (state_transition) begin
	                next_state <= W_DATA_THREE;
	            end
	            else begin
	                next_state <= W_DATA_TWO;
	            end
	        end
	        W_DATA_THREE:begin
	            if (state_transition) begin
	                next_state <= W_DATA_FOUR;
	            end
	            else begin
	                next_state <= W_DATA_THREE;
	            end
	        end
	        W_DATA_FOUR:begin
	            if (state_transition) begin
	                next_state <= STOP;
	            end
	            else begin
	                next_state <= W_DATA_FOUR;
	            end
	        end
	        R_DATA_M:begin
	            if (state_transition) begin
	                next_state <= R_DATA_L;
	            end
	            else begin
	                next_state <= R_DATA_M;
	            end
	        end
	        R_DATA_L:begin
	            if (state_transition) begin
	                next_state <= STOP;
	            end
	            else begin
	                next_state <= R_DATA_L;
	            end
	        end
	        STOP:begin
	            if (state_transition) begin
	                next_state <= FINISH;
	            end
	            else begin
	                next_state <= STOP;
	            end
	        end
	        FINISH:begin
	            if (state_transition) begin
	                next_state <= IDLE;
	            end
	            else begin
	                next_state <= FINISH;
	            end
	        end
	        default:begin
	            next_state <= IDLE;
	        end
	    endcase
	end
	always @(posedge clk or negedge rst_n) begin
	    if(!rst_n) begin
	        scl <= 1'b1;
	        sda_out <= 1'b1;
	        r_data_msb <= 8'd0;
	        r_data_lsb <= 8'd0;
	        iic_finish <= 1'b1;
	
	        sda_en <= 1'b1;
	        cnt_step <= 6'd0;
	        state_transition <= 1'b0;
	    end
	    else begin
	        state_transition <= 1'b0;
	        cnt_step <= cnt_step +1'b1;
	        case(cur_state)
	            IDLE:begin
	                scl <= 1'b1;
	                sda_en <= 1'b1;
	                sda_out <= 1'b1;
	                
	                cnt_step <= 6'd0;
	            end
	            START:begin
	                case (cnt_step)
	                    6'd0: begin
	                        iic_finish <= 1'b0;
	                        scl <= 1'b1;
	                        sda_out <= 1'b0;
	                        sda_en <= 1'b1;
	                        state_transition <= 1'b1;
	                    end
	                    6'd1: begin
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            W_SLAVE_ADDR:begin
	                case (cnt_step)
	                    6'd0: begin
	                        scl <= 1'b0;
	                    end
	                    6'd1: begin
	                        sda_out <= w_slave_addr[6];
	                    end
	                    6'd2: begin
	                        scl <= 1'b1;
	                    end
	                    6'd3: ;
	
	                    6'd4: begin
	                        scl <= 1'b0;
	                    end
	                    6'd5: begin
	                        sda_out <= w_slave_addr[5];
	                    end
	                    6'd6: begin
	                        scl <= 1'b1;
	                    end
	                    6'd7: begin
	                        
	                    end
	                    6'd8: begin
	                        scl <= 1'b0;
	                    end
	                    6'd9: begin
	                        sda_out <= w_slave_addr[4];
	                    end
	                    6'd10: begin
	                        scl <= 1'b1;
	                    end
	                    6'd11: begin
	                        
	                    end
	                    6'd12: begin
	                        scl <= 1'b0;
	                    end
	                    6'd13: begin
	                        sda_out <= w_slave_addr[3];
	                    end
	                    6'd14: begin
	                        scl <= 1'b1;
	                    end
	                    6'd15: begin
	                        
	                    end
	                    6'd16: begin
	                        scl <= 1'b0;
	                    end
	                    6'd17: begin
	                        sda_out <= w_slave_addr[2];
	                    end
	                    6'd18: begin
	                        scl <= 1'b1;
	                    end
	                    6'd19: begin
	                        
	                    end
	                    6'd20: begin
	                        scl <= 1'b0;
	                    end
	                    6'd21: begin
	                        sda_out <= w_slave_addr[1];
	                    end
	                    6'd22: begin
	                        scl <= 1'b1;
	                    end
	                    6'd23: begin
	                        
	                    end
	                    6'd24: begin
	                        scl <= 1'b0;
	                    end
	                    6'd25: begin
	                        sda_out <= w_slave_addr[0];
	                    end
	                    6'd26: begin
	                        scl <= 1'b1;
	                    end
	                    6'd27: begin
	                        
	                    end
	                    6'd28: begin
	                        scl <= 1'b0;
	                    end
	                    6'd29: begin
	                        sda_out <= w_r_cmd;
	                    end
	                    6'd30: begin
	                        scl <= 1'b1;
	                    end
	                    6'd31: begin
	                        
	                    end
	                    6'd32: begin
	                        scl <= 1'b0;
	                    end
	                    6'd33: begin
	                        sda_en <= 1'b0;
	                    end
	                    6'd34: begin
	                        scl <= 1'b1;
	                    end
	                    6'd35: begin
	                        state_transition <= 1'b1;
	                    end
	                    6'd36: begin
	                        scl <= 1'b0;
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            W_REG_ADDR:begin
	                case (cnt_step)
	                    6'd0: begin
	                        sda_en <= 1'b1;
	                        sda_out <= w_reg_addr[7];
	                    end
	                    6'd1: begin
	                        scl <= 1'b1;
	                    end
	                    6'd2: ;
	
	                    6'd3: begin
	                        scl <= 1'b0;
	                    end
	                    6'd4: begin
	                        sda_out <= w_reg_addr[6];
	                    end
	                    6'd5: begin
	                        scl <= 1'b1;
	                    end
	                    6'd6: ;
	
	                    6'd7: begin
	                        scl <= 1'b0;
	                    end
	                    6'd8: begin
	                        sda_out <= w_reg_addr[5];
	                    end
	                    6'd9: begin
	                        scl <= 1'b1;
	                    end
	                    6'd10: ;
	
	                    6'd11: begin
	                        scl <= 1'b0;
	                    end
	                    6'd12: begin
	                        sda_out <= w_reg_addr[4];
	                    end
	                    6'd13: begin
	                        scl <= 1'b1;
	                    end
	                    6'd14: ;
	
	                    6'd15: begin
	                        scl <= 1'b0;
	                    end
	                    6'd16: begin
	                        sda_out <= w_reg_addr[3];
	                    end
	                    6'd17: begin
	                        scl <= 1'b1;
	                    end
	                    6'd18: ;
	
	                    6'd19: begin
	                        scl <= 1'b0;
	                    end
	                    6'd20: begin
	                        sda_out <= w_reg_addr[2];
	                    end
	                    6'd21: begin
	                        scl <= 1'b1;
	                    end
	                    6'd22: ;
	
	                    6'd23: begin
	                        scl <= 1'b0;
	                    end
	                    6'd24: begin
	                        sda_out <= w_reg_addr[1];
	                    end
	                    6'd25: begin
	                        scl <= 1'b1;
	                    end
	                    6'd26: ;
	
	                    6'd27: begin
	                        scl <= 1'b0;
	                    end
	                    6'd28: begin
	                        sda_out <= w_reg_addr[0];
	                    end
	                    6'd29: begin
	                        scl <= 1'b1;
	                    end
	                    6'd30: ;
	
	                    6'd31: begin
	                        scl <= 1'b0;
	                    end
	                    6'd32: begin
	                        sda_en <= 1'b0;
	                    end
	                    6'd33: begin
	                        scl <= 1'b1;
	                    end
	                    6'd34: begin
	                        state_transition <= 1'b1;
	                    end
	                    6'd35: begin
	                        scl <= 1'b0;
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            W_DATA_ONE:begin
	                case (cnt_step)
	                    6'd0: begin
	                        sda_en <= 1'b1;
	                        sda_out <= w_data_one[7];
	                    end
	                    6'd1: begin
	                        scl <= 1'b1;
	                    end
	                    6'd2: ;
	
	                    6'd3: begin
	                        scl <= 1'b0;
	                    end
	                    6'd4: begin
	                        sda_out <= w_data_one[6];
	                    end
	                    6'd5: begin
	                        scl <= 1'b1;
	                    end
	                    6'd6: ;
	
	                    6'd7: begin
	                        scl <= 1'b0;
	                    end
	                    6'd8: begin
	                        sda_out <= w_data_one[5];
	                    end
	                    6'd9: begin
	                        scl <= 1'b1;
	                    end
	                    6'd10: ;
	
	                    6'd11: begin
	                        scl <= 1'b0;
	                    end
	                    6'd12: begin
	                        sda_out <= w_data_one[4];
	                    end
	                    6'd13: begin
	                        scl <= 1'b1;
	                    end
	                    6'd14: ;
	
	                    6'd15: begin
	                        scl <= 1'b0;
	                    end
	                    6'd16: begin
	                        sda_out <= w_data_one[3];
	                    end
	                    6'd17: begin
	                        scl <= 1'b1;
	                    end
	                    6'd18: ;
	
	                    6'd19: begin
	                        scl <= 1'b0;
	                    end
	                    6'd20: begin
	                        sda_out <= w_data_one[2];
	                    end
	                    6'd21: begin
	                        scl <= 1'b1;
	                    end
	                    6'd22: ;
	
	                    6'd23: begin
	                        scl <= 1'b0;
	                    end
	                    6'd24: begin
	                        sda_out <= w_data_one[1];
	                    end
	                    6'd25: begin
	                        scl <= 1'b1;
	                    end
	                    6'd26: ;
	
	                    6'd27: begin
	                        scl <= 1'b0;
	                    end
	                    6'd28: begin
	                        sda_out <= w_data_one[0];
	                    end
	                    6'd29: begin
	                        scl <= 1'b1;
	                    end
	                    6'd30: ;
	
	                    6'd31: begin
	                        scl <= 1'b0;
	                    end
	                    6'd32: begin
	                        sda_en <= 1'b0;
	                    end
	                    6'd33: begin
	                        scl <= 1'b1;
	                    end
	                    6'd34: begin
	                        state_transition <= 1'b1;
	                    end
	                    6'd35: begin
	                        scl <= 1'b0;
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            W_DATA_TWO:begin
	                case (cnt_step)
	                    6'd0: begin
	                        sda_en <= 1'b1;
	                        sda_out <= w_data_two[7];
	                    end
	                    6'd1: begin
	                        scl <= 1'b1;
	                    end
	                    6'd2: ;
	
	                    6'd3: begin
	                        scl <= 1'b0;
	                    end
	                    6'd4: begin
	                        sda_out <= w_data_two[6];
	                    end
	                    6'd5: begin
	                        scl <= 1'b1;
	                    end
	                    6'd6: ;
	
	                    6'd7: begin
	                        scl <= 1'b0;
	                    end
	                    6'd8: begin
	                        sda_out <= w_data_two[5];
	                    end
	                    6'd9: begin
	                        scl <= 1'b1;
	                    end
	                    6'd10: ;
	
	                    6'd11: begin
	                        scl <= 1'b0;
	                    end
	                    6'd12: begin
	                        sda_out <= w_data_two[4];
	                    end
	                    6'd13: begin
	                        scl <= 1'b1;
	                    end
	                    6'd14: ;
	
	                    6'd15: begin
	                        scl <= 1'b0;
	                    end
	                    6'd16: begin
	                        sda_out <= w_data_two[3];
	                    end
	                    6'd17: begin
	                        scl <= 1'b1;
	                    end
	                    6'd18: ;
	
	                    6'd19: begin
	                        scl <= 1'b0;
	                    end
	                    6'd20: begin
	                        sda_out <= w_data_two[2];
	                    end
	                    6'd21: begin
	                        scl <= 1'b1;
	                    end
	                    6'd22: ;
	
	                    6'd23: begin
	                        scl <= 1'b0;
	                    end
	                    6'd24: begin
	                        sda_out <= w_data_two[1];
	                    end
	                    6'd25: begin
	                        scl <= 1'b1;
	                    end
	                    6'd26: ;
	
	                    6'd27: begin
	                        scl <= 1'b0;
	                    end
	                    6'd28: begin
	                        sda_out <= w_data_two[0];
	                    end
	                    6'd29: begin
	                        scl <= 1'b1;
	                    end
	                    6'd30: ;
	
	                    6'd31: begin
	                        scl <= 1'b0;
	                    end
	                    6'd32: begin
	                        sda_en <= 1'b0;
	                    end
	                    6'd33: begin
	                        scl <= 1'b1;
	                    end
	                    6'd34: begin
	                        state_transition <= 1'b1;
	                    end
	                    6'd35: begin
	                        scl <= 1'b0;
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            W_DATA_THREE:begin
	                case (cnt_step)
	                    6'd0: begin
	                        sda_en <= 1'b1;
	                        sda_out <= w_data_three[7];
	                    end
	                    6'd1: begin
	                        scl <= 1'b1;
	                    end
	                    6'd2: ;
	
	                    6'd3: begin
	                        scl <= 1'b0;
	                    end
	                    6'd4: begin
	                        sda_out <= w_data_three[6];
	                    end
	                    6'd5: begin
	                        scl <= 1'b1;
	                    end
	                    6'd6: ;
	
	                    6'd7: begin
	                        scl <= 1'b0;
	                    end
	                    6'd8: begin
	                        sda_out <= w_data_three[5];
	                    end
	                    6'd9: begin
	                        scl <= 1'b1;
	                    end
	                    6'd10: ;
	
	                    6'd11: begin
	                        scl <= 1'b0;
	                    end
	                    6'd12: begin
	                        sda_out <= w_data_three[4];
	                    end
	                    6'd13: begin
	                        scl <= 1'b1;
	                    end
	                    6'd14: ;
	
	                    6'd15: begin
	                        scl <= 1'b0;
	                    end
	                    6'd16: begin
	                        sda_out <= w_data_three[3];
	                    end
	                    6'd17: begin
	                        scl <= 1'b1;
	                    end
	                    6'd18: ;
	
	                    6'd19: begin
	                        scl <= 1'b0;
	                    end
	                    6'd20: begin
	                        sda_out <= w_data_three[2];
	                    end
	                    6'd21: begin
	                        scl <= 1'b1;
	                    end
	                    6'd22: ;
	
	                    6'd23: begin
	                        scl <= 1'b0;
	                    end
	                    6'd24: begin
	                        sda_out <= w_data_three[1];
	                    end
	                    6'd25: begin
	                        scl <= 1'b1;
	                    end
	                    6'd26: ;
	
	                    6'd27: begin
	                        scl <= 1'b0;
	                    end
	                    6'd28: begin
	                        sda_out <= w_data_three[0];
	                    end
	                    6'd29: begin
	                        scl <= 1'b1;
	                    end
	                    6'd30: ;
	
	                    6'd31: begin
	                        scl <= 1'b0;
	                    end
	                    6'd32: begin
	                        sda_en <= 1'b0;
	                    end
	                    6'd33: begin
	                        scl <= 1'b1;
	                    end
	                    6'd34: begin
	                        state_transition <= 1'b1;
	                    end
	                    6'd35: begin
	                        scl <= 1'b0;
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            W_DATA_FOUR:begin
	                case (cnt_step)
	                    6'd0: begin
	                        sda_en <= 1'b1;
	                        sda_out <= w_data_four[7];
	                    end
	                    6'd1: begin
	                        scl <= 1'b1;
	                    end
	                    6'd2: ;
	
	                    6'd3: begin
	                        scl <= 1'b0;
	                    end
	                    6'd4: begin
	                        sda_out <= w_data_four[6];
	                    end
	                    6'd5: begin
	                        scl <= 1'b1;
	                    end
	                    6'd6: ;
	
	                    6'd7: begin
	                        scl <= 1'b0;
	                    end
	                    6'd8: begin
	                        sda_out <= w_data_four[5];
	                    end
	                    6'd9: begin
	                        scl <= 1'b1;
	                    end
	                    6'd10: ;
	
	                    6'd11: begin
	                        scl <= 1'b0;
	                    end
	                    6'd12: begin
	                        sda_out <= w_data_four[4];
	                    end
	                    6'd13: begin
	                        scl <= 1'b1;
	                    end
	                    6'd14: ;
	
	                    6'd15: begin
	                        scl <= 1'b0;
	                    end
	                    6'd16: begin
	                        sda_out <= w_data_four[3];
	                    end
	                    6'd17: begin
	                        scl <= 1'b1;
	                    end
	                    6'd18: ;
	
	                    6'd19: begin
	                        scl <= 1'b0;
	                    end
	                    6'd20: begin
	                        sda_out <= w_data_four[2];
	                    end
	                    6'd21: begin
	                        scl <= 1'b1;
	                    end
	                    6'd22: ;
	
	                    6'd23: begin
	                        scl <= 1'b0;
	                    end
	                    6'd24: begin
	                        sda_out <= w_data_four[1];
	                    end
	                    6'd25: begin
	                        scl <= 1'b1;
	                    end
	                    6'd26: ;
	
	                    6'd27: begin
	                        scl <= 1'b0;
	                    end
	                    6'd28: begin
	                        sda_out <= w_data_four[0];
	                    end
	                    6'd29: begin
	                        scl <= 1'b1;
	                    end
	                    6'd30: ;
	
	                    6'd31: begin
	                        scl <= 1'b0;
	                    end
	                    6'd32: begin
	                        sda_en <= 1'b0;
	                    end
	                    6'd33: begin
	                        scl <= 1'b1;
	                    end
	                    6'd34: begin
	                        state_transition <= 1'b1;
	                    end
	                    6'd35: begin
	                        scl <= 1'b0;
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            R_DATA_M:begin
	                case (cnt_step)
	                    6'd0: ;
	                    6'd1: begin
	                        scl <= 1'b1;
	                    end
	                    6'd2: begin
	                        r_data_msb[7] <= sda_in;
	                    end
	
	                    6'd3:  begin
	                        scl <= 1'b0;
	                    end
	                    6'd4: ;
	                    6'd5:  begin
	                        scl <= 1'b1;
	                    end
	                    6'd6:  begin
	                        r_data_msb[6] <= sda_in;
	                    end
	
	                    6'd7:  begin
	                        scl <= 1'b0;
	                    end
	                    6'd8:  ;
	                    6'd9:  begin
	                        scl <= 1'b1;
	                    end
	                    6'd10: begin
	                        r_data_msb[5] <= sda_in;
	                    end
	
	                    6'd11: begin
	                        scl <= 1'b0;
	                    end
	                    6'd12: ;
	                    6'd13: begin
	                        scl <= 1'b1;
	                    end
	                    6'd14: begin
	                        r_data_msb[4] <= sda_in;
	                    end
	
	                    6'd15: begin
	                        scl <= 1'b0;
	                    end
	                    6'd16: ;
	                    6'd17: begin
	                        scl <= 1'b1;
	                    end
	                    6'd18: begin
	                        r_data_msb[3] <= sda_in;
	                    end
	
	                    6'd19: begin
	                        scl <= 1'b0;
	                    end
	                    6'd20: ;
	                    6'd21: begin
	                        scl <= 1'b1;
	                    end
	                    6'd22: begin
	                        r_data_msb[2] <= sda_in;
	                    end
	                        
	                    6'd23: begin
	                        scl <= 1'b0;
	                    end
	                    6'd24: ;
	                    6'd25: begin
	                        scl <= 1'b1;
	                    end
	                    6'd26: begin
	                        r_data_msb[1] <= sda_in;
	                    end
	
	                    6'd27: begin
	                        scl <= 1'b0;
	                    end
	                    6'd28: ;
	                    6'd29: begin
	                        scl <= 1'b1;
	                    end
	                    6'd30: begin
	                        r_data_msb[0] <= sda_in;
	                    end
	
	                    6'd31: begin
	                        scl <= 1'b0;
	                    end
	                    6'd32: begin
	                        sda_en <= 1'b1;
	                        sda_out <= 1'b0;
	                    end
	                    6'd33: begin
	                        scl <= 1'b1;
	                    end
	                    6'd34: begin
	                        state_transition <= 1'b1;
	                    end
	                    6'd35: begin
	                        scl <= 1'b0;
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            R_DATA_L:begin
	                case (cnt_step)
	                    6'd0: begin
	                        sda_en <= 1'b0;
	                    end
	                    6'd1: begin
	                        scl <= 1'b1;
	                    end
	                    6'd2: begin
	                        r_data_lsb[7] <= sda_in;
	                    end
	
	                    6'd3:  begin
	                        scl <= 1'b0;
	                    end
	                    6'd4:  ;
	                    6'd5:  begin
	                        scl <= 1'b1;
	                    end
	                    6'd6:  begin
	                        r_data_lsb[6] <= sda_in;
	                    end
	
	                    6'd7:  begin
	                        scl <= 1'b0;
	                    end
	                    6'd8:  ;
	                    6'd9:  begin
	                        scl <= 1'b1;
	                    end
	                    6'd10: begin
	                        r_data_lsb[5] <= sda_in;
	                    end
	
	                    6'd11: begin
	                        scl <= 1'b0;
	                    end
	                    6'd12: ;
	                    6'd13: begin
	                        scl <= 1'b1;
	                    end
	                    6'd14: begin
	                        r_data_lsb[4] <= sda_in;
	                    end
	
	                    6'd15: begin
	                        scl <= 1'b0;
	                    end
	                    6'd16: ;
	                    6'd17: begin
	                        scl <= 1'b1;
	                    end
	                    6'd18: begin
	                        r_data_lsb[3] <= sda_in;
	                    end
	
	                    6'd19: begin
	                        scl <= 1'b0;
	                    end
	                    6'd20: ;
	                    6'd21: begin
	                        scl <= 1'b1;
	                    end
	                    6'd22: begin
	                        r_data_lsb[2] <= sda_in;
	                    end
	                        
	                    6'd23: begin
	                        scl <= 1'b0;
	                    end
	                    6'd24: ;
	                    6'd25: begin
	                        scl <= 1'b1;
	                    end
	                    6'd26: begin
	                        r_data_lsb[1] <= sda_in;
	                    end
	
	                    6'd27: begin
	                        scl <= 1'b0;
	                    end
	                    6'd28: ;
	                    6'd29: begin
	                        scl <= 1'b1;
	                    end
	                    6'd30: begin
	                        r_data_lsb[0] <= sda_in;
	                    end
	
	                    6'd31: begin
	                        scl <= 1'b0;
	                    end
	                    6'd32: begin
	                        sda_en <= 1'b1;
	                        sda_out <= 1'b1;
	                    end
	                    6'd33: begin
	                        scl <= 1'b1;
	                    end
	                    6'd34: begin
	                        state_transition <= 1'b1;
	                    end
	                    6'd35: begin
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            STOP:begin
	                case (cnt_step)
	                    6'd0: begin
	                        sda_out <= 1'b0;
	                        state_transition <= 1'b1;
	                    end
	                    6'd1: begin
	                        sda_out <= 1'b1;
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	            FINISH:begin
	                case (cnt_step)
	                    6'd0: begin
	                        iic_finish <= 1'b1;
	                        state_transition <= 1'b1;
	                    end
	                    6'd1: begin
	                        cnt_step <= 6'd0;
	                    end
	                    default: ;
	                endcase
	            end
	        endcase
	    end
	end
	
	
	
endmodule    //i2c_ip

